(defun c:addprop()
  (vl-load-com)
  (setq oAcad (vlax-get-acad-object)
	oDoc (vla-get-ActiveDocument oAcad)
	oModelSpace (vla-get-ModelSpace oDoc)
	oLine (vla-AddLine oModelSpace (vlax-3d-point 0 0) (vlax-3d-point 4 4))
	saXtype (vlax-make-safearray vlax-vbInteger '(0 . 4))
	saXdata (vlax-make-safearray vlax-vbVariant '(0 . 4))
  )
  (vlax-safearray-fill saXtype '(1001 1040 1071 1071 1000))
  (vlax-safearray-fill saXdata '("AsdkCAD" 13.0 0 0 "Kean"))
  (vla-setXData oLine (vlax-make-variant saXtype) (vlax-make-variant saXdata))
  (setq oProp1 (vla-GetInterfaceObject oAcad "OpmX.Property.1")
	oProp2 (vla-GetInterfaceObject oAcad "OpmX.Property.1")
	oProp3 (vla-GetInterfaceObject oAcad "OpmX.Property.1")
	oProp4 (vla-GetInterfaceObject oAcad "OpmX.Property.1")
  )
  ; first a simple property
  (vlax-put-property oProp1 "CategoryName" "Sample Category")
  (vlax-put-property oProp1 "ClassName" "AcDbLine")
  (vlax-put-property oProp1 "Description" "This is property of type double")
  (vlax-put-property oProp1 "DisplayName" "Property1")
  (vlax-invoke-method oProp1 "SetDataSource" "AsdkCAD" 1040 1)
  (vlax-invoke-method oProp1 "Add")

  ;then an enum property
  (vlax-put-property oProp2 "CategoryName" "Sample Category")
  (vlax-put-property oProp2 "ClassName" "AcDbLine")
  (vlax-put-property oProp2 "Description" "This is property of named integers")
  (vlax-put-property oProp2 "DisplayName" "Property2")
  (vlax-put-property oProp2 "ReadOnly" 0)
  (setq saNames1 (vlax-make-safearray vlax-vbString '(0 . 2))
	saValues1 (vlax-make-safearray vlax-vbVariant '(0 . 2))
  )
  (vlax-safearray-fill saNames1 '("Name1" "Name2" "Name3"))
  (vlax-safearray-fill saValues1 '(1 2 3))
  (vlax-invoke-method oProp2 "SetDataSource" "AsdkCAD" 1071 1)
  (vlax-invoke-method oProp2 "SetEnums" (vlax-make-variant saNames1) (vlax-make-variant saValues1))
  (vlax-invoke-method oProp2 "Add")

  ; Let's see boolean property
  (vlax-put-property oProp3 "CategoryName" "Sample Category")
  (vlax-put-property oProp3 "ClassName" "AcDbLine")
  (vlax-put-property oProp3 "Description" "This is a boolean property")
  (vlax-put-property oProp3 "DisplayName" "Property3")
  (vlax-put-property oProp3 "ReadOnly" 0)
  (setq saNames2 (vlax-make-safearray vlax-vbString '(0 . 1))
	saValues2 (vlax-make-safearray vlax-vbVariant '(0 . 1))
  )
  (vlax-safearray-fill saNames2 '("True" "False"))
  (vlax-safearray-fill saValues2 '(1 0))
  (vlax-invoke-method oProp3 "SetDataSource" "AsdkCAD" 1071 2)
  (vlax-invoke-method oProp3 "SetEnums" (vlax-make-variant saNames2) (vlax-make-variant saValues2))
  (vlax-invoke-method oProp3 "Add")

  ; A string
  (vlax-put-property oProp4 "CategoryName" "Sample Category")
  (vlax-put-property oProp4 "ClassName" "AcDbLine")
  (vlax-put-property oProp4 "Description" "This is a string property")
  (vlax-put-property oProp4 "DisplayName" "Property4")
  (vlax-put-property oProp4 "ReadOnly" 0)
  (vlax-invoke-method oProp4 "SetDataSource" "AsdkCAD" 1000 1)
  (vlax-invoke-method oProp4 "Add")
  (princ)
)

(defun c:removeprop()
  (vlax-release-object oProp1)
  (vlax-release-object oProp2)
  (vlax-release-object oProp3)
  (vlax-release-object oProp4)
  )